/**
 * ARInterface.h
 * 
 *
 * @authors $Author: $ - Malf
 * @version $Id: $
 */



#ifndef _ARINTERFACE_H_
#define _ARINTERFACE_H_

#if defined(__cplusplus)
extern "C" {
#endif


#ifdef WIN32                 
#include <windows.h>    /* necessary because of the Microsoft OpenGL headers dependency */
#endif

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include <glut.h>

#include <iup.h>
#include <iupcontrols.h>
#include <iupgl.h>

#include <im.h>
#include <im_capture.h>
#include <im_format_avi.h>
#include <im_image.h>
#include <im_util.h>

#include "image.h"
#include "3dsLoad.h"


#define WIDTH 320
#define HEIGHT 240

void IconLibOpen(void); /* implemented in "iconlib.c" to load standard icon images into IUP */
void userOpen(int width, int height,char *model_file_name);
void userProcessLeft(int width, int height, unsigned char* inFrame, int* flags, float* values, unsigned char* outFrame);
void userProcessRight(int width, int height, unsigned char* inFrame, int* flags, float* values, unsigned char* outFrame);
void userDrawLeft(int width, int height);
void userDrawRight(int width, int height);
void userClose( );
void itfResetImageData(struct _itfData *itfData);


struct _itfData   /* interface variables */
{
   imFile* capFile;             /* file input */
   imVideoCapture* capVideo;    /* live capture input */
   int imgFileIndex;         /* -1 = paused */
   unsigned char* supFrame;       /* opengl display buffer (sup) */
   unsigned char* infFrame;
   int            frameWidth;
   int            frameHeight;
   int            saveVideo;
   int            saveProcessedVideo;
   imFile* videoFile;
   imFile* processedVideoFile;
   /* Global to help enable/disable items in the interface */
   Ihandle *supCanvas, *infCanvas,
            *configBut, *configMenu,
            *captureMenu, *saveBut, *saveProcessedBut;
   int     canvasWidth;
   int     canvasHeight;
}  itfDataLeft = {NULL,NULL,0,NULL,NULL,0,0,0,0, NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL, 0,0},
   itfDataRight = {NULL,NULL,0,NULL,NULL,0,0,0,0, NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL, 0,0};


struct _usrData
{
   Ihandle *statusLabel, *userButton0, *userButton1, *userButton2, *userButton3, *userButton4, *userButton5;
   int        usrFlags[6];			//F's
   float    usrValues[2];		//scrolls
}usrData={NULL,NULL,NULL,NULL,NULL,NULL,NULL,{0,0,0,0,0,0},{0.5f,0.5f}};


struct _globalData
{
   Ihandle *TypeOfCaptureBut, *showCounterBut, *captureBut, 
           *counterDialog,    *counterCanvas, *timer;
   int captureLive;         /*false or true*/
   int TypeOfCapture;      /*0:n frames or 1:one frame*/
   int showingCounter;   /*false or true*/
   unsigned char *character[10];
}globalData={NULL,NULL,NULL,NULL,NULL,NULL,1,0,0,NULL};



#if defined(__cplusplus)
}
#endif

#endif

