/**
 * ARProcess.h
 *
 * Implements GUI load facilities.
 *
 * @author $Author: Malf $
 * @version $Id: $
 */


#ifndef _ARPROCESS_H_
#define _ARPROCESS_H_

#if defined(__cplusplus)
extern "C" {
#endif

#ifdef WIN32            
#include <windows.h>    /* necessary because of the Microsoft OpenGL headers dependency */
#endif
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdio.h>
#include <math.h>

#include <lib3ds/file.h>                        
#include <lib3ds/camera.h>
#include <lib3ds/mesh.h>
#include <lib3ds/node.h>
#include <lib3ds/material.h>
#include <lib3ds/matrix.h>
#include <lib3ds/vector.h>
#include <lib3ds/light.h>
#include <lib3ds/config.h>

#include "jv.h"
#include "glut.h"
#include "tsai.h"
#include "im.h"
#include "3dsLoad.h"

/* Long lines detected in images */
#define MAX_DETECTABLE_LINES 256
#define MAX_INTERSECTIONS 256

//TSAI!
//Verificar usabilidade
#define SQR(x) ((x)*(x))
#define NEARPLANE  1
#define FARPLANE  5000
#define _NEW_POINTS_ 1
#define NPTSX 8
#define NPTSY 8
#ifndef _PI_
#define _PI_ 3.1415926535897932384626433832795
#endif
#define IMAGE_W 320
#define IMAGE_H 240


#if defined(__cplusplus)
}
#endif

#endif

